package fr.boucaron.fortune;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Random;
import java.util.StringTokenizer;

import fr.boucaron.fortune.R;
import android.app.Activity;
import android.graphics.Typeface;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.TextView;
import android.widget.LinearLayout.LayoutParams;

public class Fortune extends Activity {

	TextView t; 
	int current;
	ArrayList<String> fortunes;
	MediaPlayer _mediaPlayer; 

	void loadFortune(String url) {
		try {
			URL _url = new URL(url);
			BufferedReader in = new BufferedReader(
					new InputStreamReader(
							_url.openStream()));

			String inputLine;
			String whole = new String();
			while ((inputLine = in.readLine()) != null) {
				whole += inputLine + "\n"; 
			}
			StringTokenizer tok = new StringTokenizer(whole,"%");
			while(tok.hasMoreElements()) {
				fortunes.add(tok.nextToken());
			}

			in.close();

		} 
		catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	void updateFortune() {
		Random r = new Random();
		int tmp   = r.nextInt(fortunes.size());
		if ( tmp != current ) { current = tmp ; }
		else  { current = (current+1)%fortunes.size(); }
		t.setText(fortunes.get(current));
	}

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		fortunes = new ArrayList<String>();
		_mediaPlayer = new MediaPlayer();
		_mediaPlayer.reset();
		try {
			//_mediaPlayer.setDataSource("/system/media/audio/ringtones/ringer.mp3");
			_mediaPlayer.setDataSource("/system/media/audio/songs/fortune.mp3");
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		_mediaPlayer.prepareAsync();
		_mediaPlayer.setLooping(1);
		_mediaPlayer.start();
		t = new TextView(this);
	//	t.setBackground(R.drawable.fortunecookie);
		t.setTypeface(Typeface.MONOSPACE);
		t.setText("Fortune, just push on center to run");
		LayoutParams lp = new LayoutParams( LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT);
		this.addContentView(t, lp); 
		this.loadFortune("http://julien.boucaron.free.fr/fortune.aoste");   
	}

	/** KeyBoard listener */ 
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		if ( keyCode == KeyEvent.KEYCODE_DPAD_CENTER) {
			updateFortune();
			return true;
		}
		return false;
	}
	
	public void onPause() {
		_mediaPlayer.pause();
		super.onPause();
	}
	
	public void onResume() {
		_mediaPlayer.start();
		super.onPostResume();
	}
	
	
} 

